using Microsoft.Web.WebView2.Core;
using System.Drawing.Imaging;
using System;
using System.Drawing;
using System.IO;
using System.Net.Http;
using System.Windows.Forms;
using Microsoft.Web.WebView2.Core;
using Microsoft.Web.WebView2.WinForms;
using Microsoft.Web.WebView2.Wpf;

namespace EdgeVoyager
{
    public partial class Form1 : Form
    {
        int zoom = 100;
        public Form1()
        {
            InitializeComponent();
            InitializeAsync(); 
        }

        private void CoreWebView2_NewWindowRequested(object sender, CoreWebView2NewWindowRequestedEventArgs e)
        {
            Form1 newForm = new Form1();
            // ´WebView2SourceΪҪ򿪵
            newForm.webView21.Source = new Uri(e.Uri);
            // ʾ´
            newForm.Show();
            // HandledΪtrueʾѾ´
            e.Handled = true;
        }

        async void InitializeAsync()
        {
            await webView21.EnsureCoreWebView2Async(null);
            // webView2WebView2ؼʵ
            await webView21.EnsureCoreWebView2Async(null);
            webView21.CoreWebView2.Profile.PreferredColorScheme = CoreWebView2PreferredColorScheme.Light;
            webView21.CoreWebView2.NewWindowRequested += CoreWebView2_NewWindowRequested;
            if (Settings1.Default.firstwindow == true)
            {
                webView21.CoreWebView2.Navigate("https://cn.bing.com/?mkt=zh-CN");
                Settings1.Default.firstwindow = false;
                Settings1.Default.Save();
            }
        }

        private void back_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoBack();
        }

        private void forward_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoForward();
        }

        private void refresh_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Reload();
        }

        private void stop_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Stop();
        }

        private void search_button_Click(object sender, EventArgs e)
        {

        }

        private void webView21_NavigationStarting(object sender, CoreWebView2NavigationStartingEventArgs e)
        {
            string currentUrl = webView21.Source.ToString();
            if (!comboBox1.Items.Contains(currentUrl))
            {
                comboBox1.Items.Add(currentUrl);
            }
            comboBox1.Text = currentUrl;
            progressBar.Value = 0;
            progressLabel.Text = "0%";
            StatusLabel.Text = "ʼ" + currentUrl; 
        }

        private async void webView21_NavigationCompleted(object sender, CoreWebView2NavigationCompletedEventArgs e)
        {
            string currentUrl = webView21.Source.ToString();
            if (!comboBox1.Items.Contains(currentUrl))
            {
                comboBox1.Items.Add(currentUrl);
            }
            comboBox1.Text = currentUrl;
            progressBar.Value = 100;
            progressLabel.Text = "100%";
            StatusLabel.Text = "ɡ"; 
            string title = await webView21.CoreWebView2.ExecuteScriptAsync("document.title;");
            this.Text = "LYKNS EdgeVoyager" + title.Trim('"');

            string faviconUrl = await webView21.CoreWebView2.ExecuteScriptAsync("Array.from(document.querySelectorAll('link[rel=\"icon\"], link[rel=\"shortcut icon\"]')).map(link => link.href).find(url => url);");
            faviconUrl = faviconUrl.Trim('"'); // ȥ

            if (!string.IsNullOrEmpty(faviconUrl))
            {
                using (var client = new HttpClient())
                {
                    var faviconData = await client.GetByteArrayAsync(faviconUrl);
                    using (var ms = new MemoryStream(faviconData))
                    {
                        using (var img = Image.FromStream(ms))
                        {
                            if (img is Bitmap bitmap)
                            {
                                this.Icon = Icon.FromHandle(bitmap.GetHicon());
                            }
                            else
                            {
                                // ͼƬBitmapͣԿʽȡͼ
                                // 磬ԳԽͼƬ浽ļȻʹIcon.ExtractAssociatedIconȡͼ
                                // ֱʹimgΪͼ꣨У
                                // ֱʹimgΪͼΪȷimgΪͼ꣩
                                this.Icon = Icon.FromHandle(((Bitmap)img.Clone()).GetHicon());
                            }
                        }
                    }
                }
            }
        }

        private void comboBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                string url = comboBox1.Text;
                if (Uri.IsWellFormedUriString(url, UriKind.Absolute))
                {
                    webView21.CoreWebView2.Navigate(url);
                }
                else
                {
                    MessageBox.Show("Чַ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void ˳XToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        private void webView21_ContentLoading(object sender, CoreWebView2ContentLoadingEventArgs e)
        {
            progressBar.Value = 50; // ʱΪ50%
            progressLabel.Text = "50%";
            StatusLabel.Text = "ݿʼ";
        }
        private async void SetZoomLevel(double zoomLevel)
        {
            await webView21.CoreWebView2.ExecuteScriptAsync($"document.body.style.zoom = '{zoomLevel}%'");
        }

        private void toolStripSplitButton1_ButtonClick(object sender, EventArgs e)
        {
            SetZoomLevel(100);
            toolStripMenuItem3.Enabled = true;
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            zoom = zoom + 25;
            SetZoomLevel(zoom);
            toolStripMenuItem3.Enabled = true;
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            zoom = zoom - 25;
            SetZoomLevel(zoom);
            if (zoom == 25)
                toolStripMenuItem3.Enabled = false;
        }

        private void ˢRToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Reload();
        }

        private void ֹͣTToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Stop();
        }

        private void ǰQToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoForward();
        }

        private void WToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoBack();
        }
    }
}
